VERSION 5.00
Begin VB.UserControl RSPBzip2 
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   2745
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3060
   InvisibleAtRuntime=   -1  'True
   MaskPicture     =   "UserControl1.ctx":0000
   MouseIcon       =   "UserControl1.ctx":00FA
   Picture         =   "UserControl1.ctx":0404
   ScaleHeight     =   2745
   ScaleWidth      =   3060
   ToolboxBitmap   =   "UserControl1.ctx":070E
   Begin VB.Timer Timer2 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   1920
      Top             =   1680
   End
   Begin VB.Timer Timer1 
      Enabled         =   0   'False
      Interval        =   100
      Left            =   480
      Top             =   1440
   End
End
Attribute VB_Name = "RSPBzip2"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'Project: <html>
'<head>
'<meta name="GENERATOR" content="Microsoft FrontPage 3.0">
'<title></title>
'</head>
'<body>
'<table border="0" cellpadding="5" cellspacing="5">
'<tbody>
'  <tr>
'    <td><p align="right"><font color="#808080" size="1" face="Verdana">Last update:<!--webbot
'    bot="Timestamp" s-type="EDITED" s-format="%d-%b-%Y %H:%M:%S" --></font><font
'    face="Courier"> </font></p>
'    <p align="center"><font color="#0000ff" size="5" face="Verdana">RSP Bzip2 Compressor 1.2.0</font></p>
'    <p><br>
'    ActiveX OCX to compress files in the Bzip2 format<br>
'    <br>
'    <br>
'    What is new in the version 1.2.0 : New CPU detection rotines , speed improvement up to 20
'    percent faster than older versions , many small bugs fixed , several new error handlings
'    added also</p>
'    <big style="color: rgb(0, 0, 153);"><big><p align="center">Features</big></big></p>
'    <p align="left"><br>
'    - Ability to compress and decompress in the Bzip2 format<br>
'    <br>
'    - The control can pause , resume and cancel the compression and decompression execution<br>
'    <br>
'    - The compression code is loaded dinamically in the process of the software using the
'    control<br>
'    <br>
'    - The control can provide progress information about the compression and decompression
'    functions<br>
'    <br>
'    - The code execution is optimized for speed , but the original Bzip2 compression format is
'    really slow to execute , future versions may have a faster implementation of the Bzip2
'    compression format <br>
'    <big style="color: rgb(0, 0, 153);"><big><br>
'    </big></big></p>
'    <div align="center"><big style="color: rgb(0, 0, 153);"><big><p>Instal</big></big><br>
'    <br>
'    </p>
'    <p align="left">- To install the control , open the package , decompress &quot;OCX
'    install.zip&quot; and execute setup.exe , it will initialize the installation execution of
'    the control<br>
'    - To use the sample , decompress the &quot;sample project.zip&quot; to an empty folder and
'    load the project in your VB<br>
'    - To uninstall the control , search for the package in the add/remove applications in the
'    controle panel , and select remove , it will remove the control From the system<br>
'    <br>
'    </p>
'    </div><p><br>
'    </td>
'  </tr>
'</tbody>
'</table>
'
'<p>&nbsp; </p>
'
'<p><br>
'<br>
'<br>
'</p>
'</body>
'</html>




'Author: RSP Software - http://rspsoftware.clic3.net <br>



'Purpose: Public Event Finished()<br>
'<br>This event will be raised in the end of the execution<br>
Public Event Finished()

'Purpose: Public Event Progress(Progressvalue As Long)<br>
'<br>This event will provide a graphical view of the compression progress<br>
Public Event Progress(Progressvalue As Long)

'Purpose: Public Event ErrorCode(ErrorNumber As Long, ErrorDescription As String)<br>
'<br>This event will return the errors generated in the control<br>
Public Event ErrorCode(ErrorNumber As Long, ErrorDescription As String)
Private Bzip As New ZipClass


Private Declare Function GetTickCount Lib "kernel32" () As Long

Private Sub Timer1_Timer()
    
    Bzip.Init
    
    Dim Progressvalue As Long
    Static Progress As Long
    Dim ret As Long
    
    ret = Bzip.CallWindowInt("getprogress", 0, 0, 0)
    
    If Progress <> ret Then
        
        If ret > 97 Then
            
            RaiseEvent Progress(97)
        Else
            RaiseEvent Progress(ret)
        End If
        
        
    End If
    
    Progress = ret
    
End Sub

Private Sub Timer2_Timer()
    Dim ret As Long
    Static OldValue As Long
    
    'ret = status(0)
    ret = Bzip.CallWindowInt("status", 0, 0, 0)
    
    
    If ret = 0 Then
        'Label2.Caption = "finished"
        Timer2.Enabled = False
        Timer1.Enabled = False
        
        RaiseEvent Progress(100)
        ret = Bzip.CallWindowInt("intreturn", 0, 0, 0)
        'RaiseEvent ErrorCode(ret, "Desc")
        RaiseEvent Finished
        'aqui ele pode checar o valor de saida e ver no que deu
        
        
    End If
    
    
    
End Sub

Private Sub UserControl_Resize()
    
    UserControl.Height = 550
    UserControl.Width = 550
    
End Sub


'Purpose: Public Function Compress(ByVal InputFile As String, ByVal Outputfile As String, CompressionLevel As Long)<br>
'<br>Function to compress a file in the Bzip2 format<br>
'<br>With the version 1.2.0 and above the compression speed was optimized in a magnitude of 20 percent when compared with older versions , this optimization is due to new programming improvements based on new Intel and AMD processors <br>
'<br>CompressionLevel range from 0 to 9 , 9 to best compression ( but slower) <br>
Public Function Compress(ByVal Inputfile As String, _
    ByVal OutPutFile As String, CompressionLevel As Long)
    
    Bzip.Init
    
    Dim ret As Long
    
    
    ret = Bzip.CallWindowInt("status", 0, 0, 0)
    
    If (ret = 1) Then
        
        PrintError 7
        Exit Function
    End If
    
    
    Dim infile As String
    Dim OutFile As String
    Dim level As String
    Dim Comando As Long
    
    If Bzip.CheckForEquality(Inputfile, OutPutFile) Then
        PrintError 2 'The input file is the same as the output
        Exit Function
    End If
    If Bzip.CheckForEmpty(Inputfile) Then
        PrintError 3 'The input file is empty
        Exit Function
    End If
    If Bzip.CheckForEmpty(OutPutFile) Then
        PrintError 4 'The outputfile file is empty
        Exit Function
    End If
    
    If Not Bzip.CheckInputFile(Inputfile) Then
        PrintError 5 'The input file or path is invalid
        Exit Function
    End If
    If Not Bzip.CheckOuPutFile(OutPutFile) Then
        PrintError 6 'The output file or path is invalid
        Exit Function
    End If
    
    infile = Inputfile & Chr(0)
    OutFile = OutPutFile & Chr(0)
    
    'criar a rotina para testar arquivos e testar diretorios
    
    If CompressionLevel > 9 Or CompressionLevel < 0 Then
        PrintError 1 ' Invalid compression level
        'Compress = False
        Exit Function
    End If
    
    level = "w" & CompressionLevel & Chr(0)
    Comando = 0
    
    'ret = status(1)
    
    ret = Bzip.CallWindowInt("status", 1, 0, 0)
    
    
    'ret = execute(infile, OutFile, level, Comando)
    ret = Bzip.CallWindow("compress", infile, OutFile, level)
    
    Timer2.Enabled = True
    Timer1.Enabled = True
    
    
    RaiseEvent Progress(0)
    
    
End Function

'Purpose: Public Function Decompress(ByVal InputFile As String, ByVal Outputfile As String)<br>
'<br>Function to decompress a Bzip2 file<br>
'<br>With the version 1.2.0 and above the decompression speed was optimized in a magnitude up to 20 percent when compared with older versions , this optimization is due to new programming improvements based on new Intel and AMD processors <br>
Public Function Decompress(ByVal Inputfile As String, ByVal OutPutFile As String)
    
    Bzip.Init
    
    
    Dim ret As Long
    
    
    ret = Bzip.CallWindowInt("status", 0, 0, 0)
    
    If (ret = 1) Then
        
        PrintError 7
        Exit Function
    End If
    
    Dim infile As String
    Dim OutFile As String
    Dim level As String
    Dim Comando As Long
    
    If Bzip.CheckForEquality(Inputfile, OutPutFile) Then
        PrintError 2 'The input file is the same as the output
        Exit Function
    End If
    If Bzip.CheckForEmpty(Inputfile) Then
        PrintError 3 'The input file is empty
        Exit Function
    End If
    If Bzip.CheckForEmpty(OutPutFile) Then
        PrintError 4 'The outputfile file is empty
        Exit Function
    End If
    
    If Not Bzip.CheckInputFile(Inputfile) Then
        PrintError 5 'The input file or path is invalid
        Exit Function
    End If
    If Not Bzip.CheckOuPutFile(OutPutFile) Then
        PrintError 6 'The output file or path is invalid
        Exit Function
    End If
    infile = Inputfile & Chr(0)
    OutFile = OutPutFile & Chr(0)
    
    'criar a rotina para testar arquivos e testar diretorios
    
    If CompressionLevel > 9 Or CompressionLevel < 0 Then
        PrintError 1 ' Invalid compression level
        'Decompress = False
        
        Exit Function
    End If
    
    level = "w" & CompressionLevel & Chr(0)
    Comando = 0
    
    'ret = status(1)
    
    ret = Bzip.CallWindowInt("status", 1, 0, 0)
    
    
    
    'ret = execute(infile, OutFile, level, Comando)
    ret = Bzip.CallWindow("decompress", infile, OutFile, "w9")
    
    Timer2.Enabled = True
    Timer1.Enabled = True
    
    RaiseEvent Progress(0)
    
End Function
Private Function PrintError(Value As Long)
    
    Select Case Value
        
    Case 1
        RaiseEvent ErrorCode(1, "Invalid compression level ")
    Case 2
        RaiseEvent ErrorCode(2, "The input file is the same as the output")
    Case 3
        RaiseEvent ErrorCode(3, "The input file is empty ")
    Case 4
        RaiseEvent ErrorCode(4, "The outputfile file is empty ")
    Case 5
        RaiseEvent ErrorCode(5, "The input file or path is invalid")
    Case 6
        RaiseEvent ErrorCode(6, "The output file or path is invalid")
    Case 7
        RaiseEvent ErrorCode(7, "Already running , call the cancel function or wait for the end of execution")
        
    End Select
    
End Function

Private Sub UserControl_Terminate()
    
    
    
    Dim ret As Long
    
    'case the program was loaded
    If Bzip.IsLoaded Then
        ret = Bzip.CallWindowInt("status", 0, 0, 0)
        
        If (ret = 0) Then
            
            Bzip.Deinit
            
        End If
    End If
    

'    'Public Declare Function GetTickCount Lib "kernel32" () As Long
'    ret = GetTickCount
'
'    If ret Mod 7 = 0 Then
'        About
'    End If
'
    
End Sub

'Purpose: Public Function About()<br>
'<br>This function will show an aboutbox of the control<br>
Public Function About()
    
    Form1.Show vbModal
    
End Function
'Purpose: Public Function PauseCompress()<br>
'<br>To pause the compression or decompression <br>
Public Function PauseCompress()
    
    
    If Bzip.IsLoaded Then
        
        ret = Bzip.CallWindowInt("pause", 0, 0, 0)
    End If
    
End Function
'Purpose: Public Function ResumeCompress()<br>
'<br>To resume the compression or decompression <br>
Public Function ResumeCompress()
    
    If Bzip.IsLoaded Then
        ret = Bzip.CallWindowInt("bresume", 0, 0, 0)
    End If
    
End Function
'Purpose: Public Function CancelCompress()<br>
'<br>To cancel the compression or decompression<br>
Public Function CancelCompress()
    
    
    
    
    '    Bzip.Init
    
    If Bzip.IsLoaded Then
        Dim ret As Long
        
        ret = Bzip.CallWindowInt("cancel", 0, 0, 0)
    End If
    
End Function
'Purpose: Public Function ControlName() As String<br>
'<br>This retrieve the name of the control<br>
Public Function ControlName() As String
    
    ControlName = App.Title
    
End Function

'Purpose: Public Function GetCPUVendor() As String<br>
'<br>This function will retrieve the vendor string name embedded in the installed processor<br>
Public Function GetCPUVendor() As String
    
    Bzip.Init
    Dim ret As Long
    
    Dim TheString As String
    
    TheString = Space(300)
    
    ret = Bzip.CallWindow2("getcpuname", TheString, " ", 0)
    
    GetCPUVendor = TheString
    
End Function


'Purpose: Public Function GetCPUBrandString() As String<br>
'<br>This function will retrieve the brand string name embedded in the installed processor  ( if available , of course )<br>
Public Function GetCPUBrandString() As String
    
    Bzip.Init
    Dim ret As Long
    
    Dim TheString As String
    
    TheString = Space(300)
    
    ret = Bzip.CallWindow2("getbrandstring", TheString, " ", 0)
    
    GetCPUBrandString = TheString
    
End Function
